var hljs = require('highlight.js');
const path = require('path');
function copy_plugin(md) {
  // 保存原始的 code_block 和 fence 规则
  const origCodeBlockRule = md.renderer.rules.code_block;
  const origFenceRule = md.renderer.rules.fence;
  // 定义一个函数，用于在渲染代码块时添加复制按钮
  function renderCodeWithCopyButton(tokens, idx, options, env, self) {
    // 添加语法高亮
    let highlightedContent = tokens[idx].content;
    const lang = tokens[idx].info;
    if (lang && hljs.getLanguage(lang)) {
      try {
        highlightedContent = hljs.highlight(tokens[idx].content, { language: lang }).value;
      } catch (__) { }
    }
    const content = tokens[idx].content.replace(/"/g, '&quot;');
    // 在渲染结果中添加一个复制按钮
    let result = `
<div style="position: relative">
 <pre><code>${highlightedContent}</code></pre>
 <button class="code-copy-button" data-clipboard-text="${content}">  
 COPY
 </button>
</div>
`;
    return result;
  }
  // 覆盖 code_block 和 fence 规则，以便在渲染代码块时添加复制按钮
  md.renderer.rules.code_block = renderCodeWithCopyButton;
  md.renderer.rules.fence = renderCodeWithCopyButton;
}
module.exports = {
  enhanceAppFiles: path.resolve(__dirname, './enhanceApp.js'),
  extendMarkdown: md => {
    md.use(require('markdown-it-katex'));
    md.use(copy_plugin);
  }
};
